#include <windowsx.h>
#include "dcopynt.h"

HWND	hWnd;
HWND    g_hWnd;
HINSTANCE hInst;
int stopthread1=0,always_format=0,verify_data=0,retries=5,fat_selection=1;
char def_image[255],user_filter[255]="\0\0";

long FAR PASCAL MainWndProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
	switch (message) {
	case WM_CREATE: // Initialize Global vars
		break;

	case WM_PAINT:
		break;

	case WM_COMMAND:	// message: command from application menu
		switch(wParam)
		{
			default:
				break;
		}
		break;

	case WM_QUIT:
	case WM_DESTROY:	// message: window being destroyed
			PostQuitMessage(0);
		break;

	default:			// Passes it on if unproccessed
		return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	return 0;
}

void GetSourceFile(HWND hWnd)
{
  OPENFILENAME openFile;
  char filename[512]="\0";
  char filter[100]="Disk Images *.IMG\0*.IMG\0All Files\0*.*\0\0\0",tmp[40];

  openFile.lStructSize=sizeof(OPENFILENAME);
  openFile.hwndOwner=hWnd;
  openFile.hInstance=NULL;
  openFile.lpstrFilter=filter;
  openFile.lpstrCustomFilter=user_filter;
  openFile.nMaxCustFilter=255;
  openFile.nFilterIndex=0;
  openFile.lpstrFile=filename;
  openFile.nMaxFile=512;
  openFile.lpstrFileTitle=NULL;
  openFile.nMaxFileTitle=0;
  openFile.lpstrInitialDir=NULL;
  openFile.lpstrTitle=NULL;
  openFile.Flags=OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
  openFile.nFileOffset=0;
  openFile.nFileExtension=0;
  openFile.lpstrDefExt="img";
  openFile.lCustData=0;
  openFile.lpfnHook=NULL;
  openFile.lpTemplateName=NULL;
  GetOpenFileName(&openFile);
  if (user_filter[1])
  {
    strcpy(tmp,&user_filter[strlen(user_filter)+1]);
    sprintf(user_filter,"Custom %s",tmp);
    strcpy(&user_filter[strlen(user_filter)+1],tmp);
  }
  if (filename[0])
  {
    SetDlgItemText(hWnd,IDC_SOURCE_FILE,filename);
    SendDlgItemMessage(hWnd,IDC_SOURCE_DISK,BM_SETCHECK,0,0);
    SendDlgItemMessage(hWnd,IDC_SOURCE_IMAGE,BM_SETCHECK,1,0);
  }
}

void GetTargetFile(HWND hWnd)
{
  OPENFILENAME openFile;
  char filename[512]="\0";
  char filter[100]="Disk Images *.IMG\0*.IMG\0All Files\0*.*\0\0\0",tmp[40];

  openFile.lStructSize=sizeof(OPENFILENAME);
  openFile.hwndOwner=hWnd;
  openFile.hInstance=NULL;
  openFile.lpstrFilter=filter;
  openFile.lpstrCustomFilter=user_filter;
  openFile.nMaxCustFilter=255;
  openFile.nFilterIndex=0;
  openFile.lpstrFile=filename;
  openFile.nMaxFile=512;
  openFile.lpstrFileTitle=NULL;
  openFile.nMaxFileTitle=0;
  openFile.lpstrInitialDir=NULL;
  openFile.lpstrTitle=NULL;
  openFile.Flags=OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;
  openFile.nFileOffset=0;
  openFile.nFileExtension=0;
  openFile.lpstrDefExt="img";
  openFile.lCustData=0;
  openFile.lpfnHook=NULL;
  openFile.lpTemplateName=NULL;
  GetSaveFileName(&openFile);
  if (user_filter[1])
  {
    strcpy(tmp,&user_filter[strlen(user_filter)+1]);
    sprintf(user_filter,"Custom %s",tmp);
    strcpy(&user_filter[strlen(user_filter)+1],tmp);
  }
  if (filename[0])
  {
    SetDlgItemText(hWnd,IDC_TARGET_FILE,filename);
    SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_SETCHECK,0,0);
    SendDlgItemMessage(hWnd,IDC_TARGET_IMAGE,BM_SETCHECK,1,0);
  }
}

void Error(HWND hWnd,char *str)
{
  MessageBox(hWnd,str,NULL,MB_OK|MB_ICONERROR);
}

BOOL FAR PASCAL AboutProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  switch (message) 
  {
    case WM_INITDIALOG:
      return TRUE;
    case WM_CLOSE:
      EndDialog(hWnd,TRUE);
      return TRUE;
    case WM_COMMAND:
      switch (wParam)
      {
	case IDOK: 
	  EndDialog(hWnd,TRUE);
	  return TRUE;
	default:
	  break;
      }
  }
  return FALSE;
}

void SetOptions(HWND hWnd)
{
  char str[10];

  always_format=SendDlgItemMessage(hWnd,IDC_FORMAT_TARGET,BM_GETCHECK,1,0);
  verify_data=SendDlgItemMessage(hWnd,IDC_VERIFY_DATA,BM_GETCHECK,1,0);
  fat_selection=SendDlgItemMessage(hWnd,IDC_FAT_SELECTION,BM_GETCHECK,1,0);
  GetDlgItemText(hWnd,IDC_RETRIES,str,10);
  retries=atoi(str);
  if (retries<=0)
  {
    retries=5;
  }
}

BOOL FAR PASCAL DlgProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  FARPROC aboutproc;
  char tmp[40];
  
  switch (message) 
  {
    case WM_INITDIALOG:
      SendMessage(hWnd,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(ICO_DCOPYNT)));
      SendMessage(hWnd,WM_SETICON,(WPARAM)ICON_SMALL,(LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(ICO_DCOPYNT)));
      SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_SETCHECK,1,0);
      SendDlgItemMessage(hWnd,IDC_FAT_SELECTION,BM_SETCHECK,fat_selection,0);
      SendDlgItemMessage(hWnd,IDC_VERIFY_DATA,BM_SETCHECK,verify_data,0);
      SendDlgItemMessage(hWnd,IDC_FORMAT_TARGET,BM_SETCHECK,always_format,0);
      EnableWindow(GetDlgItem(hWnd,IDC_WRITE),FALSE);
      EnableWindow(GetDlgItem(hWnd,IDC_VERIFY),FALSE);
      sprintf(tmp,"%d",retries);
      SetDlgItemText(hWnd,IDC_RETRIES,tmp);
      if (def_image[0])
      {
				if (def_image[0]=='"')
				{
          memmove(def_image,&def_image[1],strlen(def_image));
					def_image[strlen(def_image)-1]=0;
				}
        SetDlgItemText(hWnd,IDC_SOURCE_FILE,def_image);
        SendDlgItemMessage(hWnd,IDC_SOURCE_IMAGE,BM_SETCHECK,1,0);
      }
      else
        SendDlgItemMessage(hWnd,IDC_SOURCE_DISK,BM_SETCHECK,1,0);
      g_hWnd=hWnd;
      return TRUE;
    case WM_PAINT:
      break;
    case WM_CLOSE:
      PostQuitMessage(0);
      break;
    case WM_COMMAND:
      SetOptions(hWnd);
      switch (wParam)
      {
        case IDC_CANCEL: 
	  PostQuitMessage(0);
	  break;
	case IDC_SOURCE_BUTTON:
	  GetSourceFile(hWnd);
	  break;
	case IDC_TARGET_BUTTON:
	  GetTargetFile(hWnd);
	  break;
	case IDC_START:
	  if (SendDlgItemMessage(hWnd,IDC_SOURCE_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	  {
	    if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	      Working(CopyDiskToDisk,hWnd);
	    else
	      Working(CopyDiskToImage,hWnd);
	  }
	  else
	  {
	    if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	      Working(CopyImageToDisk,hWnd);
	    else
	      Working(CopyImageToImage,hWnd);
	  }
          SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETPOS,0,0);
	  break;
	case IDC_COMPARE:
	  if (SendDlgItemMessage(hWnd,IDC_SOURCE_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	  {
	    if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	      Working(CompareDiskToDisk,hWnd);
	    else
	      Working(CompareDiskToImage,hWnd);
	  }
	  else
	  {
	    if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	      Working(CompareImageToDisk,hWnd);
	    else
	      Working(CompareImageToImage,hWnd);
	  }
          SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETPOS,0,0);
	  break;
	case IDC_ABOUT:
	  aboutproc=MakeProcInstance((FARPROC)AboutProc,hInst);
	  DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,(DLGPROC)aboutproc);
	  FreeProcInstance(aboutproc);
	  break;
	case IDC_READ:
	  if (SendDlgItemMessage(hWnd,IDC_SOURCE_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	    Working(CopyDiskToMemory,hWnd);
	  else
	    Working(CopyImageToMemory,hWnd);
	  break;
	case IDC_WRITE:
	  if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	    Working(CopyMemoryToDisk,hWnd);
	  else
	    Working(CopyMemoryToImage,hWnd);
	  break;
	case IDC_VERIFY:
	  if (SendDlgItemMessage(hWnd,IDC_TARGET_DISK,BM_GETCHECK,0,0)==BST_CHECKED)
	    Working(CompareMemoryToDisk,hWnd);
	  else
	    Working(CompareMemoryToImage,hWnd);
	  break;
	case IDC_FORMAT:
	  Working(FormatTargetDisk,hWnd);
	default:
	  break;


      }
      break;
  }
  return FALSE;
}

BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASSEX  wc;

	// Fill in window class structure with parameters that describe the
	// main window.

	wc.cbSize=sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;	// Class style(s).
	wc.lpfnWndProc = (WNDPROC)MainWndProc;	// Function to retrieve messages for
														// windows of this class.
	wc.cbClsExtra = 0;	// No per-class extra data.
	wc.cbWndExtra = 0;	// No per-window extra data.
	wc.hInstance = hInstance;	// Application that owns the class.
	wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(ICO_DCOPYNT));
	wc.hIconSm = LoadIcon(hInstance, MAKEINTRESOURCE(ICO_DCOPYNT));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;	// Name of menu resource in .RC file.
	wc.lpszClassName = "DCOPYNT";	// Name used in call to CreateWindow.

	/* Register the window class and return success/failure code. */

	return (RegisterClassEx(&wc));

}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;	// Main window handle.


	/* Create a main window for this application instance.  */

	hWnd = CreateWindow(
		"DCOPYNT", 	               // See RegisterClass() call.
		"DCOPY for NT",	  	      // Text for window title bar.
		WS_OVERLAPPEDWINDOW,	      // Window style.
		CW_USEDEFAULT, 			   // Default horizontal position.
		CW_USEDEFAULT,	   	   	// Default vertical position.
		CW_USEDEFAULT,	      		// Default width.
		CW_USEDEFAULT, 		   	// Default height.
		NULL,		   		         // Overlapped windows have no parent.
		NULL,	   			         // Use the window class menu.
		hInstance,  			      // This instance owns this window.
		NULL			   	         // Pointer not needed.
	);

	/* If window could not be created, return "failure" */

	if (!hWnd)
		return (FALSE);

	/* Make the window visible; update its client area; and return "success" */

//      ShowWindow(hWnd, nCmdShow);	// Show the window
//	UpdateWindow(hWnd);			// Sends WM_PAINT message
	return (TRUE);				// Returns the value from PostQuitMessage

}

BOOL InitDialog(HWND hWnd,HINSTANCE hInstance,int nCmdShow)
{
  FARPROC dlgproc;
  
  dlgproc=MakeProcInstance((FARPROC)DlgProc,hInst);
	  DialogBox(hInst,MAKEINTRESOURCE(IDD_DCOPYNT),hWnd,(DLGPROC)dlgproc);
	  FreeProcInstance(dlgproc);
  return TRUE;
}

void WriteToRegistry(char *key,char *subkey,DWORD type,char *value)
{
  HKEY hk;
  DWORD dp;
  int sz;

  if (type==REG_SZ)
    sz=strlen(value)+1;
  else if (type==REG_MULTI_SZ)
    sz=strlen(value)+strlen(&value[strlen(value)+1])+4;
  if (RegCreateKeyEx(
      HKEY_LOCAL_MACHINE,
      key,
      0,
      "REG_SZ",
      REG_OPTION_NON_VOLATILE,
      KEY_ALL_ACCESS,
      NULL,
      &hk,
      &dp)!=ERROR_SUCCESS)
    return;
  RegSetValueEx(hk,subkey,0,type,value,sz);
  RegCloseKey(hk);
}

BOOLEAN ReadFromRegistry(char *key,char *subkey,char *value)
{
  HKEY hk;
  DWORD sz=255,type;

  if (RegOpenKeyEx(
      HKEY_LOCAL_MACHINE,
      key,
      0,
      KEY_ALL_ACCESS,
      &hk)!=ERROR_SUCCESS)
    return FALSE;
  if (RegQueryValueEx(hk,subkey,0,&type,value,&sz)!=ERROR_SUCCESS)
  {
    RegCloseKey(hk);
    return FALSE;
  }
  RegCloseKey(hk);
  return TRUE;
}

int PASCAL WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;			// message
	char tmp[255];

	if (!hPrevInstance)	// Other instances of app running?
	  if (!InitApplication(hInstance))	// Initialize shared things
	    return (FALSE);	// Exits if unable to initialize

	/* Perform initializations that apply to a specific instance */

        hInst=hInstance;
	strncpy(def_image,lpCmdLine,255);
	if (ReadFromRegistry("SOFTWARE\\DCopyNT","AlwaysFormat",tmp))
	  always_format=atoi(tmp);
	if (ReadFromRegistry("SOFTWARE\\DCopyNT","VerifyData",tmp))
	  verify_data=atoi(tmp);
	if (ReadFromRegistry("SOFTWARE\\DCopyNT","FATSelection",tmp))
	  fat_selection=atoi(tmp);
	if (ReadFromRegistry("SOFTWARE\\DCopyNT","Retries",tmp))
	  retries=atoi(tmp);
	ReadFromRegistry("SOFTWARE\\DCopyNT","CustomFilter",user_filter);

	if (!InitInstance(hInstance, nCmdShow))
	  return (FALSE);
	if (!InitDialog(hWnd,hInstance,nCmdShow))
	  return FALSE;

	/* Acquire and dispatch messages until a WM_QUIT message is received. */

	while (GetMessage(&msg,	// message structure
		NULL,	// handle of window receiving the message
		0,	// lowest message to examine
		0)==1)	// highest message to examine
	{
	TranslateMessage(&msg);	// Translates virtual key codes
	DispatchMessage(&msg);	// Dispatches message to window
	}
	if (buffer)
	  GlobalFree(buffer);
	if (fulltrack)
	  GlobalFree(fulltrack);
	sprintf(tmp,"%d",always_format);
	WriteToRegistry("SOFTWARE\\DCopyNT","AlwaysFormat",REG_SZ,tmp);
	sprintf(tmp,"%d",verify_data);
	WriteToRegistry("SOFTWARE\\DCopyNT","VerifyData",REG_SZ,tmp);
	sprintf(tmp,"%d",fat_selection);
	WriteToRegistry("SOFTWARE\\DCopyNT","FATSelection",REG_SZ,tmp);
	sprintf(tmp,"%d",retries);
	WriteToRegistry("SOFTWARE\\DCopyNT","Retries",REG_SZ,tmp);
	WriteToRegistry("SOFTWARE\\DCopyNT","CustomFilter",REG_MULTI_SZ,user_filter);
	return (msg.wParam);	// Returns the value from PostQuitMessage
}

