#include "dcopynt.h"

int g_do_format,quickformat=0;
DISK_GEOMETRY w_dg;

void ShowDiskFormat(HWND hWnd,WORD wParam)
{
  int tracks,sectors,sides;
  char str[10];

  switch (wParam)
  {
    case IDC_DF160:
      tracks=40;
      sectors=8;
      sides=1;
      break;
    case IDC_DF180:
      tracks=40;
      sectors=9;
      sides=1;
      break;
    case IDC_DF320:
      tracks=40;
      sectors=8;
      sides=2;
      break;
    case IDC_DF360:
      tracks=40;
      sectors=9;
      sides=2;
      break;
    case IDC_DF720:
      tracks=80;
      sectors=9;
      sides=2;
      break;
    case IDC_DF800:
      tracks=80;
      sectors=10;
      sides=2;
      break;
    case IDC_DF1200:
      tracks=80;
      sectors=15;
      sides=2;
      break;
    case IDC_DF1440:
      tracks=80;
      sectors=18;
      sides=2;
      break;
    case IDC_DF1680:
      tracks=80;
      sectors=21;
      sides=2;
      break;
    default:
      return;
  }
  sprintf(str,"%d",tracks);
  SetDlgItemText(hWnd,IDC_DF_TRACKS,str);
  sprintf(str,"%d",sectors);
  SetDlgItemText(hWnd,IDC_DF_SECTORS,str);
  sprintf(str,"%d",sides);
  SetDlgItemText(hWnd,IDC_DF_SIDES,str);
}

BOOL FAR PASCAL AskFormatProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  char str[10];

  switch (message)
  {
    case WM_INITDIALOG:
      SendDlgItemMessage(hWnd,IDC_DF1440,BM_SETCHECK,1,0);
      ShowDiskFormat(hWnd,IDC_DF1440);
      if (g_do_format)
        ShowWindow(GetDlgItem(hWnd,IDC_QUICK_FORMAT),SW_SHOW);
      return TRUE;
    case WM_COMMAND:
      switch (wParam)
      {
        case IDOK:
	  GetDlgItemText(hWnd,IDC_DF_TRACKS,str,10);
	  w_dg.Cylinders.QuadPart=atoi(str);
	  GetDlgItemText(hWnd,IDC_DF_SECTORS,str,10);
	  w_dg.SectorsPerTrack=atoi(str);
	  GetDlgItemText(hWnd,IDC_DF_SIDES,str,10);
	  w_dg.TracksPerCylinder=atoi(str);
          w_dg.BytesPerSector=512;
  	  quickformat=SendDlgItemMessage(hWnd,IDC_QUICK_FORMAT,BM_GETCHECK,0,0);
	  EndDialog(hWnd,1);
	  break;
	case IDCANCEL:
	  EndDialog(hWnd,0);
	  break;
        case IDC_DF_CUSTOM:
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_TRACKS),TRUE);
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_SECTORS),TRUE);
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_SIDES),TRUE);
	  break;
	case IDC_QUICK_FORMAT:
	  break;
	case IDC_DF_TRACKS:
	case IDC_DF_SECTORS:
	case IDC_DF_SIDES:
	  break;
	default:
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_TRACKS),FALSE);
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_SECTORS),FALSE);
	  EnableWindow(GetDlgItem(hWnd,IDC_DF_SIDES),FALSE);
	  ShowDiskFormat(hWnd,wParam);
	  break;
      }
  }
  return FALSE;
}

int AskDiskFormat(HWND hWnd,int do_format)
{
  FARPROC askformatproc;
  int r;

  g_do_format=do_format;
  askformatproc=MakeProcInstance((FARPROC)AskFormatProc,hInst);
  r=DialogBox(hInst,MAKEINTRESOURCE(IDD_FORMAT),hWnd,(DLGPROC)askformatproc);
  FreeProcInstance(askformatproc);
  return r;
}
